//package general;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.bson.types.ObjectId;
import org.mongodb.morphia.Morphia;
import org.mongodb.morphia.annotations.Embedded;
import org.mongodb.morphia.annotations.Entity;
import org.mongodb.morphia.annotations.Id;
import org.mongodb.morphia.annotations.Indexes;
import com.mongodb.MongoClient;

public class MorphiaBug {

	public static void main(String[] args) {
		Morphia m = new Morphia();
		m.createDatastore(new MongoClient("localhost", 27017), "dump").
		ensureIndexes(WithResource.class);
	}

	public static enum MediaVersion {
		Original, Medium, Thumbnail, Square, Tiny;

		public static boolean contains(String version) {
			for (MediaVersion v : MediaVersion.values()) {
				if (v.name().equals(version)) {
					return true;
				}
			}
			return false;
		}
	}
	public static class DescriptiveData {

	}

	@Entity
	public static class EmbeddedMediaObject {

		public void setMediaVersion(MediaVersion mediaVersion) {
			// TODO Auto-generated method stub

		}

	}

	@Entity("RecordResource")
	@Indexes({ })
	public static class WithResource<T extends DescriptiveData> {

		@Id
		private ObjectId dbId;

		public ObjectId getDbId() {
			return dbId;
		}

		public void setDbId(ObjectId dbId) {
			this.dbId = dbId;
		}

		// metadata
		@Embedded
		protected T descriptiveData;

		// all attached media Objects (their embedded part)
		@Embedded
		private List<HashMap<MediaVersion, EmbeddedMediaObject>> media;

		public WithResource() {
			this.media = new ArrayList<>();
			HashMap<MediaVersion, EmbeddedMediaObject> embedded = new HashMap<MediaVersion, EmbeddedMediaObject>();
			embedded.put(MediaVersion.Thumbnail, new EmbeddedMediaObject());
			this.media.add(embedded);
		}

		public WithResource(Class<?> clazz) {
			this.media = new ArrayList<>();
			HashMap<MediaVersion, EmbeddedMediaObject> embedded = new HashMap<MediaVersion, EmbeddedMediaObject>();
			embedded.put(MediaVersion.Thumbnail, new EmbeddedMediaObject());
			this.media.add(embedded);
		}




		public T getDescriptiveData() {
			return descriptiveData;
		}

		public void setDescriptiveData(T descriptiveData) {
			this.descriptiveData = descriptiveData;
		}



		public List<HashMap<MediaVersion, EmbeddedMediaObject>> getMedia() {
			return media;
		}

		public void setMedia(List<HashMap<MediaVersion, EmbeddedMediaObject>> media) {
			this.media = media;
		}

		public void addMediaView(MediaVersion mediaVersion,
				EmbeddedMediaObject media, int viewIndex) {
			media.setMediaVersion(mediaVersion);
			this.media.get(viewIndex).put(mediaVersion, media);
		}

		public void addMediaView(MediaVersion mediaVersion,
				EmbeddedMediaObject media) {
			HashMap<MediaVersion, EmbeddedMediaObject> e = new HashMap<>();
			e.put(mediaVersion, media);
			media.setMediaVersion(mediaVersion);
			this.media.add(e);
		}

		public void addMedia(MediaVersion mediaVersion, EmbeddedMediaObject media) {
			media.setMediaVersion(mediaVersion);
			this.media.get(0).put(mediaVersion, media);
		}


	}
	}
